/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2015-2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_predrv_reg.h
* Version      : 
* Device(s)    : 
* Tool-Chain   : 
* Description  : This file implements device driver for pre-driver module.
* Creation Date: 2016/07/05
***********************************************************************************************************************/
#ifndef PREDRV_REG_H
#define PREDRV_REG_H

/***********************************************************************************************************************
Macro definitions (Register Address)
***********************************************************************************************************************/
#define PREDRVREG_PS_ALL        (0x01)
#define PREDRVREG_PS            (0x02)
#define PREDRVREG_SW_RESET      (0x03)
#define PREDRVREG_ADC_SEL       (0x04)
#define PREDRVREG_SELSIG_U      (0x05)
#define PREDRVREG_SELSIG_V      (0x06)
#define PREDRVREG_SELSIG_W      (0x07)
#define PREDRVREG_HALL_SIG      (0x08)
#define PREDRVREG_ALMSTS1       (0x09)
#define PREDRVREG_ALMOPE1       (0x0A)
#define PREDRVREG_ALMOUT1       (0x0B)
#define PREDRVREG_ALMSTS2       (0x0C)
#define PREDRVREG_CS_SET2       (0x0D)
#define PREDRVREG_ALMOUT2       (0x0E)
#define PREDRVREG_ERROR_WAIT    (0x0F)

#define PREDRVREG_CS_SET1       (0x10)
#define PREDRVREG_HAIC_TH       (0x11)
#define PREDRVREG_PDDSTS        (0x12)
#define PREDRVREG_LD_WAIT       (0x13)
#define PREDRVREG_DRIVE_SET     (0x14)
#define PREDRVREG_DI_TIME       (0x15)
#define PREDRVREG_IDRCNT_H      (0x16)
#define PREDRVREG_IDRCNT_L      (0x17)
#define PREDRVREG_TRCNT_P       (0x18)
#define PREDRVREG_CPSET1        (0x19)
#define PREDRVREG_CPSET2        (0x1A)
#define PREDRVREG_CP_TRIM       (0x1B)

#define PREDRVREG_VREG5_TRIM    (0x20)
#define PREDRVREG_CSAMP_TRIM    (0x21)
#define PREDRVREG_ALMRAW1       (0x2C)
#define PREDRVREG_TOIN_MONI     (0x2E)
#define PREDRVREG_WHO_AM_I      (0x2F)

#define PREDRVREG_TRIM_PT       (0x30)
#define PREDRVREG_TRIM_EN       (0x3A)
#define PREDRVREG_BGR_TRIM      (0x3C)
#define PREDRVREG_BFAMP_TRIM    (0x3D)


/***********************************************************************************************************************
Macro definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Typedef definitions
***********************************************************************************************************************/
typedef enum
{
    PREDRVREG_PS_ALL_NUM = 0,
    PREDRVREG_PS_NUM,
    PREDRVREG_SW_RESET_NUM,
    PREDRVREG_ADC_SEL_NUM,
    PREDRVREG_SELSIG_U_NUM,
    PREDRVREG_SELSIG_V_NUM,
    PREDRVREG_SELSIG_W_NUM,
    PREDRVREG_HALL_SIG_NUM,
    PREDRVREG_ALMSTS1_NUM,
    PREDRVREG_ALMOPE1_NUM,
    PREDRVREG_ALMOUT1_NUM,
    PREDRVREG_ALMSTS2_NUM,
    PREDRVREG_CS_SET2_NUM,
    PREDRVREG_ALMOUT2_NUM,
    PREDRVREG_ERROR_WAIT_NUM,

    PREDRVREG_CS_SET1_NUM,
    PREDRVREG_HAIC_TH_NUM,
    PREDRVREG_PDDSTS_NUM,
    PREDRVREG_LD_WAIT_NUM,
    PREDRVREG_DRIVE_SET_NUM,
    PREDRVREG_DI_TIME_NUM,
    PREDRVREG_IDRCNT_H_NUM,
    PREDRVREG_IDRCNT_L_NUM,
    PREDRVREG_TRCNT_P_NUM,
    PREDRVREG_CPSET1_NUM,
    PREDRVREG_CPSET2_NUM,
    PREDRVREG_CP_TRIM_NUM,

    PREDRVREG_VREG5_TRIM_NUM,
    PREDRVREG_CSAMP_TRIM_NUM,
    PREDRVREG_ALMRAW1_NUM,
    PREDRVREG_TOIN_MONI_NUM,
    PREDRVREG_WHO_AM_I_NUM,

    PREDRVREG_TRIM_PT_NUM,
    PREDRVREG_TRIM_EN_NUM,
    PREDRVREG_BGR_TRIM_NUM,
    PREDRVREG_BFAMP_TRIM_NUM,

    PREDRVREG_NUM_MAX,

} predrv_reg_num_t;

/***********************************************************************************************************************
Global functions
***********************************************************************************************************************/

#endif
