/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2015-2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_sau.c
* Version      : Code Generator for RL78/G1F V1.00.01.03 [07 Mar 2016]
* Device(s)    : R5F11BLE
* Tool-Chain   : CA78K0R
* Description  : This file implements device driver for SAU module.
* Creation Date: 2016/07/13
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_sau.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
volatile uint8_t * gp_uart1_tx_address;                                 /* uart1 transmit buffer address */
volatile uint16_t  g_uart1_tx_count;                                    /* uart1 transmit data number */
volatile uint8_t * gp_uart1_rx_address;                                 /* uart1 receive buffer address */
volatile uint16_t  g_uart1_rx_count;                                    /* uart1 receive data number */
volatile uint16_t  g_uart1_rx_length;                                   /* uart1 receive data length */
volatile uint8_t * gp_csi00_rx_address;                                 /* csi00 receive buffer address */
volatile uint16_t  g_csi00_rx_length;                                   /* csi00 receive data length */
volatile uint16_t  g_csi00_rx_count;                                    /* csi00 receive data count */
volatile uint8_t * gp_csi00_tx_address;                                 /* csi00 send buffer address */
volatile uint16_t  g_csi00_send_length;                                 /* csi00 send data length */
volatile uint16_t  g_csi00_tx_count;                                    /* csi00 send data count */
volatile uint8_t * gp_csi01_rx_address;                                 /* csi01 receive buffer address */
volatile uint16_t  g_csi01_rx_length;                                   /* csi01 receive data length */
volatile uint16_t  g_csi01_rx_count;                                    /* csi01 receive data count */
volatile uint8_t * gp_csi01_tx_address;                                 /* csi01 send buffer address */
volatile uint16_t  g_csi01_send_length;                                 /* csi01 send data length */
volatile uint16_t  g_csi01_tx_count;                                    /* csi01 send data count */
/* Start user code for global. Do not edit comment generated here */
extern volatile uint8_t g_spi00_comend_flag;                            /* FALSE:SPI00 is communicating.*/
                                                                        /* TRUE :SPI is not communicating */
extern volatile uint8_t g_spi00_adcend_flag;                            /* AD conversion end flag for SPI00 ADC mode */
extern volatile uint8_t g_spi00_commode;                                /* SPI00 communication mode */
extern volatile uint8_t g_spi01_comend_flag;                            /* FALSE:SPI01 is communicating. */
                                                                        /* TRUE :SPI is not communicating */
extern volatile uint8_t g_spi01_adcend_flag;                            /* AD conversion end flag for SPI01 ADC mode */
extern volatile uint8_t g_spi01_commode;                                /* SPI00 communication mode */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: R_SAU0_Create
* Description  : This function initializes the SAU0 module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_SAU0_Create(void)
{
    SAU0EN = 1U;                                                        /* enables input clock supply */
    NOP();
    NOP();
    NOP();
    NOP();
    SPS0 = _0040_SAU_CK01_fCLK_4 | _0000_SAU_CK00_fCLK_0;
    R_UART1_Create();
    R_CSI00_Create();
    R_CSI01_Create();
}
/***********************************************************************************************************************
* Function Name: R_UART1_Create
* Description  : This function initializes the UART1 module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_UART1_Create(void)
{
    ST0 |= _0008_SAU_CH3_STOP_TRG_ON | _0004_SAU_CH2_STOP_TRG_ON;
    STMK1 = 1U;                                                         /* disable INTST1 interrupt */
    STIF1 = 0U;                                                         /* clear INTST1 interrupt flag */
    SRMK1 = 1U;                                                         /* disable INTSR1 interrupt */
    SRIF1 = 0U;                                                         /* clear INTSR1 interrupt flag */
    SREMK1 = 1U;                                                        /* disable INTSRE1 interrupt */
    SREIF1 = 0U;                                                        /* clear INTSRE1 interrupt flag */
    /* Set INTSR1 low priority */
    SRPR11 = 1U;
    SRPR01 = 1U;
    /* Set INTST1 low priority */
    STPR11 = 1U;
    STPR01 = 1U;
    SMR02 = _0020_SMR02_DEFAULT_VALUE | _8000_SAU_CLOCK_SELECT_CK01 | _0000_SAU_CLOCK_MODE_CKS | 
            _0002_SAU_MODE_UART | _0000_SAU_TRANSFER_END;
    SCR02 = _0004_SCR02_DEFAULT_VALUE | _8000_SAU_TRANSMISSION | _0000_SAU_TIMING_1 | _0000_SAU_INTSRE_MASK | 
            _0000_SAU_PARITY_NONE | _0080_SAU_LSB | _0010_SAU_STOP_1 | _0003_SAU_LENGTH_8;
    SDR02 = _CE00_SAU0_CH2_BAUDRATE_DIVISOR;
    NFEN0 |= _04_SAU_RXD1_FILTER_ON;
    SIR03 = _0004_SAU_SIRMN_FECTMN | _0002_SAU_SIRMN_PECTMN | _0001_SAU_SIRMN_OVCTMN;
    SMR03 = _0020_SMR03_DEFAULT_VALUE | _8000_SAU_CLOCK_SELECT_CK01 | _0000_SAU_CLOCK_MODE_CKS | 
            _0100_SAU_TRIGGER_RXD | _0000_SAU_EDGE_FALL | _0002_SAU_MODE_UART | _0000_SAU_TRANSFER_END;
    SCR03 = _0004_SCR03_DEFAULT_VALUE | _4000_SAU_RECEPTION | _0000_SAU_TIMING_1 | _0000_SAU_INTSRE_MASK | 
            _0000_SAU_PARITY_NONE | _0080_SAU_LSB | _0010_SAU_STOP_1 | _0003_SAU_LENGTH_8;
    SDR03 = _CE00_SAU0_CH3_BAUDRATE_DIVISOR;
    SO0 |= _0004_SAU_CH2_DATA_OUTPUT_1;
    SOL0 &= (uint16_t)~_0004_SAU_CHANNEL2_INVERTED;
    SOE0 |= _0004_SAU_CH2_OUTPUT_ENABLE;
    /* Set RxD1 pin */
    PMC0 &= 0xF7U;
    PM0 |= 0x08U;
    /* Set TxD1 pin */
    PMC0 &= 0xFBU;
    P0 |= 0x04U;
    PM0 &= 0xFBU;
}
/***********************************************************************************************************************
* Function Name: R_UART1_Start
* Description  : This function starts the UART1 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_UART1_Start(void)
{
    SO0 |= _0004_SAU_CH2_DATA_OUTPUT_1;
    SOE0 |= _0004_SAU_CH2_OUTPUT_ENABLE;
    SS0 |= _0008_SAU_CH3_START_TRG_ON | _0004_SAU_CH2_START_TRG_ON;
    STIF1 = 0U;                                                         /* clear INTST1 interrupt flag */
    SRIF1 = 0U;                                                         /* clear INTSR1 interrupt flag */
    STMK1 = 0U;                                                         /* enable INTST1 interrupt */
    SRMK1 = 0U;                                                         /* enable INTSR1 interrupt */
}
/***********************************************************************************************************************
* Function Name: R_UART1_Stop
* Description  : This function stops the UART1 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_UART1_Stop(void)
{
    STMK1 = 1U;                                                         /* disable INTST1 interrupt */
    SRMK1 = 1U;                                                         /* disable INTSR1 interrupt */
    ST0 |= _0008_SAU_CH3_STOP_TRG_ON | _0004_SAU_CH2_STOP_TRG_ON;
    SOE0 &= (uint16_t)~_0004_SAU_CH2_OUTPUT_ENABLE;
    STIF1 = 0U;                                                         /* clear INTST1 interrupt flag */
    SRIF1 = 0U;                                                         /* clear INTSR1 interrupt flag */
}
/***********************************************************************************************************************
* Function Name: R_UART1_Receive
* Description  : This function receives UART1 data.
* Arguments    : rx_buf -
*                    receive buffer pointer
*                rx_num -
*                    buffer size
* Return Value : status -
*                    MD_OK or MD_ARGERROR
***********************************************************************************************************************/
MD_STATUS R_UART1_Receive(uint8_t * const rx_buf, uint16_t rx_num)
{
    MD_STATUS status = MD_OK;

    if (rx_num < 1U)
    {
        status = MD_ARGERROR;
    }
    else
    {
        g_uart1_rx_count = 0U;
        g_uart1_rx_length = rx_num;
        gp_uart1_rx_address = rx_buf;
    }

    return (status);
}
/***********************************************************************************************************************
* Function Name: R_UART1_Send
* Description  : This function sends UART1 data.
* Arguments    : tx_buf -
*                    transfer buffer pointer
*                tx_num -
*                    buffer size
* Return Value : status -
*                    MD_OK or MD_ARGERROR
***********************************************************************************************************************/
MD_STATUS R_UART1_Send(uint8_t * const tx_buf, uint16_t tx_num)
{
    MD_STATUS status = MD_OK;

    if (tx_num < 1U)
    {
        status = MD_ARGERROR;
    }
    else
    {
        gp_uart1_tx_address = tx_buf;
        g_uart1_tx_count = tx_num;
        STMK1 = 1U;                                                     /* disable INTST1 interrupt */
        TXD1 = *gp_uart1_tx_address;
        gp_uart1_tx_address++;
        g_uart1_tx_count--;
        STMK1 = 0U;                                                     /* enable INTST1 interrupt */
    }

    return (status);
}
/***********************************************************************************************************************
* Function Name: R_CSI00_Create
* Description  : This function initializes the CSI00 module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_CSI00_Create(void)
{
    ST0 |= _0001_SAU_CH0_STOP_TRG_ON;
    CSIMK00 = 1U;                                                       /* disable INTCSI00 interrupt */
    CSIIF00 = 0U;                                                       /* clear INTCSI00 interrupt flag */
    /* Set INTCSI00 low priority */
    CSIPR100 = 1U;
    CSIPR000 = 1U;
    SIR00 = _0002_SAU_SIRMN_PECTMN | _0001_SAU_SIRMN_OVCTMN;
    SMR00 = _0020_SMR00_DEFAULT_VALUE | _0000_SAU_CLOCK_SELECT_CK00 | _0000_SAU_CLOCK_MODE_CKS | 
            _0000_SAU_TRIGGER_SOFTWARE | _0000_SAU_MODE_CSI | _0000_SAU_TRANSFER_END;
    SCR00 = _0004_SCR00_DEFAULT_VALUE | _C000_SAU_RECEPTION_TRANSMISSION | _0000_SAU_TIMING_1 | 
            _0000_SAU_INTSRE_MASK | _0000_SAU_PARITY_NONE | _0000_SAU_MSB | _0000_SAU_STOP_NONE |
            _0003_SAU_LENGTH_8;
    SDR00 = _1E00_SAU0_CH0_BAUDRATE_DIVISOR;
    SO0 |= _0100_SAU_CH0_CLOCK_OUTPUT_1;
    SO0 &= (uint16_t)~_0001_SAU_CH0_DATA_OUTPUT_1;
    SOE0 |= _0001_SAU_CH0_OUTPUT_ENABLE;
    /* Set SI00 pin */
    PM5 |= 0x01U;
    /* Set SO00 pin */
    P5 |= 0x02U;
    PM5 &= 0xFDU;
    /* Set SCK00 pin */
    P3 |= 0x01U;
    PM3 &= 0xFEU;
}
/***********************************************************************************************************************
* Function Name: R_CSI00_Start
* Description  : This function starts the CSI00 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_CSI00_Start(void)
{
    SO0 |= _0100_SAU_CH0_CLOCK_OUTPUT_1;
    SO0 &= (uint16_t)~_0001_SAU_CH0_DATA_OUTPUT_1;
    SOE0 |= _0001_SAU_CH0_OUTPUT_ENABLE;
    SS0 |= _0001_SAU_CH0_START_TRG_ON;
    CSIIF00 = 0U;                                                       /* clear INTCSI00 interrupt flag */
    CSIMK00 = 0U;                                                       /* enable INTCSI00 interrupt */
/* Start user code for include. Do not edit comment generated here */
    g_spi00_comend_flag = TRUE;
    g_spi00_adcend_flag = TRUE;
    g_spi00_commode = SPI_WAIT_MODE;
    SPI00_CS_H;
/* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: R_CSI00_Stop
* Description  : This function stops the CSI00 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_CSI00_Stop(void)
{
    CSIMK00 = 1U;                                                       /* disable INTCSI00 interrupt */
    ST0 |= _0001_SAU_CH0_STOP_TRG_ON;
    SOE0 &= (uint16_t)~_0001_SAU_CH0_OUTPUT_ENABLE;
    CSIIF00 = 0U;                                                       /* clear INTCSI00 interrupt flag */
/* Start user code for include. Do not edit comment generated here */
    g_spi00_comend_flag = TRUE;
    g_spi00_adcend_flag = TRUE;
    g_spi00_commode = SPI_WAIT_MODE;
    SPI00_CS_H;
/* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: R_CSI00_Send_Receive
* Description  : This function sends and receives CSI00 data.
* Arguments    : tx_buf -
*                    transfer buffer pointer
*                tx_num -
*                    buffer size
*                rx_buf -
*                    receive buffer pointer
* Return Value : status -
*                    MD_OK or MD_ARGERROR
***********************************************************************************************************************/
MD_STATUS R_CSI00_Send_Receive(uint8_t * const tx_buf, uint16_t tx_num, uint8_t * const rx_buf)
{
    MD_STATUS status = MD_OK;

    if (tx_num < 1U)
    {
        status = MD_ARGERROR;
    }
    else
    {
        g_csi00_tx_count = tx_num;                                      /* send data count */
        gp_csi00_tx_address = tx_buf;                                   /* send buffer pointer */
        gp_csi00_rx_address = rx_buf;                                   /* receive buffer pointer */
        CSIMK00 = 1U;                                                   /* disable INTCSI00 interrupt */
        if (gp_csi00_tx_address != 0U)
        {
            SIO00 = *gp_csi00_tx_address;                               /* started by writing data to SDR[7:0] */
            gp_csi00_tx_address++;
        }
        else
        {
            SIO00 = 0xFFU;
        }

        g_csi00_tx_count--;
        CSIMK00 = 0U;                                                   /* enable INTCSI00 interrupt */
    }

    return (status);
}
/* Start user code for adding. Do not edit comment generated here */
/***********************************************************************************************************************
* Function Name: R_CSI00_Send_Receive_SPI_mode
* Description  : This function sends and receives CSI00 data.
* Arguments    : tx_buf -
*                    transfer buffer pointer
*                tx_num -
*                    buffer size
*                rx_buf -
*                    receive buffer pointer
*                sendmode
*                    transfer mode
* Return Value : status -
*                    MD_OK or MD_ARGERROR or MD_TIMEOUTERROR
***********************************************************************************************************************/
MD_STATUS R_CSI00_Send_Receive_SPI_mode(uint8_t * const tx_buf, uint16_t tx_num, uint8_t * const rx_buf,uint8_t sendmode)
{
    MD_STATUS status = MD_OK;

    while (g_spi00_adcend_flag == FALSE)
    {
        ;
    }

    if (sendmode == SPI_ADC_MODE)
    {
        g_spi00_adcend_flag = FALSE;
    }
    SPI00_CS_L;
    g_spi00_comend_flag = FALSE;

    if (tx_num < 1U)
    {
        status = MD_ARGERROR;
    }
    else
    {
        g_spi00_commode = sendmode;                                     /* send spi mode */
        g_csi00_send_length = tx_num;                                   /* send data length */
        g_csi00_tx_count = tx_num;                                      /* send data count */
        gp_csi00_tx_address = tx_buf;                                   /* send buffer pointer */
        gp_csi00_rx_address = rx_buf;                                   /* receive buffer pointer */
        CSIMK00 = 1U;                                                   /* disable INTCSI00 interrupt */

        if (gp_csi00_tx_address != 0U)
        {
            SIO00 = *gp_csi00_tx_address;                               /* started by writing data to SDR[7:0] */
            gp_csi00_tx_address++;
        }
        else
        {
            SIO00 = 0xFFU;
        }

        g_csi00_tx_count--;
        CSIMK00 = 0U;                                                   /* enable INTCSI00 interrupt */
    }
    switch (sendmode)
    {
        case SPI_WAIT_MODE:
            while (g_spi00_comend_flag == FALSE)
            {
                NOP();
            }
            SPI00_CS_H;
        break;

        default:
        break;
    }

    return (status);
}
/* End user code. Do not edit comment generated here */
/***********************************************************************************************************************
* Function Name: R_CSI01_Create
* Description  : This function initializes the CSI01 module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_CSI01_Create(void)
{
    ST0 |= _0000_SAU_CH1_STOP_TRG_OFF;
    CSIMK01 = 1U;                                                       /* disable INTCSI01 interrupt */
    CSIIF01 = 0U;                                                       /* clear INTCSI01 interrupt flag */
    /* Set INTCSI01 low priority */
    CSIPR101 = 1U;
    CSIPR001 = 1U;

    SCR01 &= (uint16_t)~_0080_SAU_LSB;
    SCR01 &= (uint16_t)~_0002_SAU_LENGTH_7;
    SCR01 &= (uint16_t)~_0001_SAU_LENGTH_9;

    SO0 &= (uint16_t)~_0200_SAU_CH1_CLOCK_OUTPUT_1;
    SO0 &= (uint16_t)~_0002_SAU_CH1_DATA_OUTPUT_1;

    SOE0 |= _0000_SAU_CH1_OUTPUT_DISABLE;
    /* Set SI01 pin */
    PM7 |= 0x10U;
    /* Set SO01 pin */
    P7 |= 0x08U;
    PM7 &= 0xF7U;
    /* Set SCK01 pin */
    P7 |= 0x20U;
    PM7 &= 0xDFU;
}
/***********************************************************************************************************************
* Function Name: R_CSI01_Start
* Description  : This function starts the CSI01 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_CSI01_Start(void)
{
    SO0 |= _0200_SAU_CH1_CLOCK_OUTPUT_1;
    SO0 &= (uint16_t)~_0002_SAU_CH1_DATA_OUTPUT_1;
    SOE0 |= _0002_SAU_CH1_OUTPUT_ENABLE;
    SS0 |= _0002_SAU_CH1_START_TRG_ON;
    CSIIF01 = 0U;                                                       /* clear INTCSI01 interrupt flag */
    CSIMK01 = 0U;                                                       /* enable INTCSI01 interrupt */
/* Start user code for include. Do not edit comment generated here */
    g_spi01_comend_flag = TRUE;
    g_spi01_adcend_flag = TRUE;
    g_spi01_commode = SPI_WAIT_MODE;
    SPI01_CS_H;
/* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: R_CSI01_Stop
* Description  : This function stops the CSI01 module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_CSI01_Stop(void)
{
    CSIMK01 = 1U;                                                       /* disable INTCSI01 interrupt */
    ST0 |= _0002_SAU_CH1_STOP_TRG_ON;
    SOE0 &= (uint16_t)~_0002_SAU_CH1_OUTPUT_ENABLE;
    CSIIF01 = 0U;                                                       /* clear INTCSI01 interrupt flag */
/* Start user code for include. Do not edit comment generated here */
    g_spi01_comend_flag = TRUE;
    g_spi01_adcend_flag = TRUE;
    g_spi01_commode = SPI_WAIT_MODE;
    SPI01_CS_H;
/* End user code. Do not edit comment generated here */
}
/***********************************************************************************************************************
* Function Name: R_CSI01_Send_Receive
* Description  : This function sends and receives CSI01 data.
* Arguments    : tx_buf -
*                    transfer buffer pointer
*                tx_num -
*                    buffer size
*                rx_buf -
*                    receive buffer pointer
* Return Value : status -
*                    MD_OK or MD_ARGERROR
***********************************************************************************************************************/
MD_STATUS R_CSI01_Send_Receive(uint8_t * const tx_buf, uint16_t tx_num, uint8_t * const rx_buf)
{
    MD_STATUS status = MD_OK;

    if (tx_num < 1U)
    {
        status = MD_ARGERROR;
    }
    else
    {
        g_csi01_send_length = tx_num;                                   /* send data length */
        g_csi01_tx_count = tx_num;                                      /* send data count */
        gp_csi01_tx_address = tx_buf;                                   /* send buffer pointer */
        gp_csi01_rx_address = rx_buf;                                   /* receive buffer pointer */
        SMR01 |= _0001_SAU_BUFFER_EMPTY;
        CSIMK01 = 1U;                                                   /* disable INTCSI01 interrupt */

        if (gp_csi01_tx_address != 0U)
        {
            SIO01 = *gp_csi01_tx_address;                               /* started by writing data to SDR[7:0] */
            gp_csi01_tx_address++;
        }
        else
        {
            SIO01 = 0xFFU;
        }

        g_csi01_tx_count--;
        CSIMK01 = 0U;                                                   /* enable INTCSI01 interrupt */
    }

    return (status);
}
/* Start user code for adding. Do not edit comment generated here */
/***********************************************************************************************************************
* Function Name: R_CSI01_Send_Receive_SPI_mode
* Description  : This function sends and receives CSI01 data.
* Arguments    : tx_buf -
*                    transfer buffer pointer
*                tx_num -
*                    buffer size
*                rx_buf -
*                    receive buffer pointer
*                sendmode
*                    transfer mode
* Return Value : status -
*                    MD_OK or MD_ARGERROR
***********************************************************************************************************************/
MD_STATUS R_CSI01_Send_Receive_SPI_mode(uint8_t * const tx_buf, uint16_t tx_num, uint8_t * const rx_buf,uint8_t sendmode)
{
    MD_STATUS status = MD_OK;

    while (g_spi01_adcend_flag == FALSE)
    {
        ;
    }

    if (sendmode == SPI_ADC_MODE)
    {
        g_spi01_adcend_flag = FALSE;
    }
    SPI01_CS_L;
    g_spi01_comend_flag = FALSE;

    if (tx_num < 1U)
    {
        status = MD_ARGERROR;
    }
    else
    {
        g_spi01_commode = sendmode;                                     /* send spi mode */
        g_csi01_send_length = tx_num;                                   /* send data length */
        g_csi01_tx_count = tx_num;                                      /* send data count */
        gp_csi01_tx_address = tx_buf;                                   /* send buffer pointer */
        gp_csi01_rx_address = rx_buf;                                   /* receive buffer pointer */
        CSIMK01 = 1U;                                                   /* disable INTCSI01 interrupt */

        if (gp_csi01_tx_address != 0U)
        {
            SIO01 = *gp_csi01_tx_address;                               /* started by writing data to SDR[7:0] */
            gp_csi01_tx_address++;
        }
        else
        {
            SIO01 = 0xFFU;
        }

        g_csi01_tx_count--;
        CSIMK01 = 0U;                                                   /* enable INTCSI01 interrupt */
    }
    switch (g_spi01_commode)
    {
        case SPI_WAIT_MODE:
            while (g_spi01_comend_flag == FALSE)
            {
                NOP();
            }
            SPI01_CS_H;
        break;

        default:
        break;
    }

    return (status);
}

/* End user code. Do not edit comment generated here */
