/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2017-2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_tmrg.c
* Version      : Code Generator for RL78/G1F V1.00.01.03 [07 Mar 2016]
* Device(s)    : R5F11BLE
* Tool-Chain   : CA78K0R
* Description  : This file implements device driver for TMRG module.
* Creation Date: 2017/06/01
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_tmrg.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: R_TMRG0_Create
* Description  : This function initializes the TMRG module.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_TMRG0_Create(void)
{
    TRGEN = 1U;                                                         /* enables input clock supply */
    TRGMR &= (uint8_t)~_80_TMRG_COUNT_START;
    TRGMK = 1U;                                                         /* disable INTTRG interrupt */
    TRGIF = 0U;                                                         /* clear INTTRG interrupt flag */
    TRGCR = _00_TMRG_CLEAR_DISABLEED;
    TRG = _0000_TMRG_TRG_VALUE;
    TRGMR = _02_TMRG_COUNTING_MODE;
    TRGCNTC = _80_TMRG_COUNTER7_INCREMNET | _40_TMRG_COUNTER6_INCREMNET | _20_TMRG_COUNTER5_INCREMNET | 
              _10_TMRG_COUNTER4_INCREMNET | _08_TMRG_COUNTER3_INCREMNET | _04_TMRG_COUNTER2_INCREMNET | 
              _02_TMRG_COUNTER1_INCREMNET | _01_TMRG_COUNTER0_INCREMNET;
    /* Set TRGCLKA pin */
    PM0 |= 0x01U;
    /* Set TRGCLKB pin */
    PM0 |= 0x02U;
}
/***********************************************************************************************************************
* Function Name: R_TMRG0_Start
* Description  : This function starts the TMRG module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_TMRG0_Start(void)
{
    volatile uint8_t trgsr_dummy;

    trgsr_dummy = TRGSR;                                                /* read TRGSR before write 0 */
    TRGSR = 0x00U;
    TRGMR |= _80_TMRG_COUNT_START;
}
/***********************************************************************************************************************
* Function Name: R_TMRG0_Stop
* Description  : This function stops the TMRG module operation.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_TMRG0_Stop(void)
{
    volatile uint8_t trgsr_dummy;

    TRGMR &= (uint8_t)~_80_TMRG_COUNT_START;
    trgsr_dummy = TRGSR;                                                /* read TRGSR before write 0 */
    TRGSR = 0x00U;
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
